//+------------------------------------------------------------------+
//|                                           Blau_SM_Stochastic.mq5 |
//|                        Copyright 2011, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, MetaQuotes Software Corp." //  -
#property link      "http://www.mql5.com"                       //    -
#property description "Stochastic Oscillator (William Blau)"    //   mql5-
#include <WilliamBlau.mqh>                 //   (   )
//---  
#property indicator_separate_window        //     
#property indicator_buffers 13             //     
#property indicator_plots   2              //     
//---  
#property indicator_level1 -40             //   #0   
#property indicator_level2 40              //   #1   
#property indicator_levelcolor Silver      //     
#property indicator_levelstyle STYLE_DOT   //   : STYLE_DOT -  
#property indicator_levelwidth 1           //   
//---     
#property indicator_minimum -100           //      
#property indicator_maximum 100            //      
//---   #0 (Main)
#property indicator_label1  "SMI"          //     #0
#property indicator_type1   DRAW_HISTOGRAM // : DRAW_HISTOGRAM -    
#property indicator_color1  Silver         //    : Silver - 
#property indicator_style1  STYLE_SOLID    //  : STYLE_SOLID -  
#property indicator_width1  2              //  
//---   #1 (Signal Line)
#property indicator_label2  "Signal"    //     #1
#property indicator_type2   DRAW_LINE      // : DRAW_LINE - 
#property indicator_color2  Red            //    : Red - 
#property indicator_style2  STYLE_SOLID    //  : STYLE_SOLID -  
#property indicator_width2  1              //  
//---  
input int    q=5;  // q - ,     
input int    r=20; // r -  1- EMA,    
input int    s=5;  // s -  2- EMA,     
input int    u=3;  // u -  3- EMA,     
input int    ul=3; // ul - ( )  EMA,     
input ENUM_APPLIED_PRICE AppliedPrice=PRICE_CLOSE; // AppliedPrice -  
//---     
double MainBuffer[];          //    (   #0)
double SignalBuffer[];        //  : ul- EMA     (   #1)
double PriceBuffer[];         //  
double LLBuffer[];            //        q
double HHBuffer[];            //        q
double SMBuffer[];            // q-  
double EMA_SMBuffer[];        // r- 1- EMA
double DEMA_SMBuffer[];       // s- 2- EMA
double TEMA_SMBuffer[];       // u- 3- EMA
double HalfHHLLBuffer[];      //  q-   
double EMA_HalfHHLLBuffer[];  // r- 1- EMA (   )
double DEMA_HalfHHLLBuffer[]; // s- 2- EMA (   )
double TEMA_HalfHHLLBuffer[]; // u- 3- EMA (   )

//---  
int    begin1, begin2, begin3, begin4, begin5; //  ,     
int    rates_total_min; //     
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---        
   //   ;     
   //   #0
   SetIndexBuffer(0,MainBuffer,INDICATOR_DATA);                   //   
   //   #1
   SetIndexBuffer(1,SignalBuffer,INDICATOR_DATA);                 //  : ul- EMA    
   //     ;    
   SetIndexBuffer(2,PriceBuffer,INDICATOR_CALCULATIONS);          //  
   SetIndexBuffer(3,LLBuffer,INDICATOR_CALCULATIONS);             //        q
   SetIndexBuffer(4,HHBuffer,INDICATOR_CALCULATIONS);             //        q
   SetIndexBuffer(5,SMBuffer,INDICATOR_CALCULATIONS);             // q-  
   SetIndexBuffer(6,EMA_SMBuffer,INDICATOR_CALCULATIONS);         // r- 1- EMA
   SetIndexBuffer(7,DEMA_SMBuffer,INDICATOR_CALCULATIONS);        // s- 2- EMA
   SetIndexBuffer(8,TEMA_SMBuffer,INDICATOR_CALCULATIONS);        // u- 3- EMA
   SetIndexBuffer(9,HalfHHLLBuffer,INDICATOR_CALCULATIONS);       //  q-   
   SetIndexBuffer(10,EMA_HalfHHLLBuffer,INDICATOR_CALCULATIONS);  // r- 1- EMA (   )
   SetIndexBuffer(11,DEMA_HalfHHLLBuffer,INDICATOR_CALCULATIONS); // s- 2- EMA (   )
   SetIndexBuffer(12,TEMA_HalfHHLLBuffer,INDICATOR_CALCULATIONS); // u- 3- EMA (   )
/*
//---   #0 (Main)
   PlotIndexSetString(0,PLOT_LABEL,"SMI");               //     #0
   PlotIndexSetInteger(0,PLOT_DRAW_TYPE,DRAW_HISTOGRAM); // : DRAW_HISTOGRAM -    
   PlotIndexSetInteger(0,PLOT_LINE_COLOR,Silver);        //    : Silver - 
   PlotIndexSetInteger(0,PLOT_LINE_STYLE,STYLE_SOLID);   //  : STYLE_SOLID -  
   PlotIndexSetInteger(0,PLOT_LINE_WIDTH,2);             //  
//---   #1 (Signal Line)
   PlotIndexSetString(1,PLOT_LABEL,"Signal");            //     #1
   PlotIndexSetInteger(1,PLOT_DRAW_TYPE,DRAW_LINE);      // : DRAW_LINE - 
   PlotIndexSetInteger(1,PLOT_LINE_COLOR,Red);           //    : Red - 
   PlotIndexSetInteger(1,PLOT_LINE_STYLE,STYLE_SOLID);   //  : STYLE_SOLID -  
   PlotIndexSetInteger(1,PLOT_LINE_WIDTH,1);             //  
*/
//---    
   IndicatorSetInteger(INDICATOR_DIGITS,2);
/*
//---  
   IndicatorSetInteger(INDICATOR_LEVELS,2);                //     
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,-40);         //   #0   
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,40);          //   #1   
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,Silver);       //     
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,STYLE_DOT);    //   : STYLE_DOT -  
   IndicatorSetInteger(INDICATOR_LEVELWIDTH,1);            //   
   IndicatorSetString(INDICATOR_LEVELTEXT,0,"Oversold");   //   #0 ""
   IndicatorSetString(INDICATOR_LEVELTEXT,1,"Overbought"); //   #1 ""
//---     
   IndicatorSetDouble(INDICATOR_MINIMUM,-100); //      
   IndicatorSetDouble(INDICATOR_MAXIMUM,100);  //      
*/
//---
   begin1=q-1;         //                                    -  : SMBuffer[], HalfHHLLBuffer[], LLBuffer[], HHBuffer[]
   begin2=begin1+r-1;  // or =(q-1)+(r-1)                    -  : EMA_...[]
   begin3=begin2+s-1;  // or =(q-1)+(r-1)+(s-1)              -  : DEMA_...[]
   begin4=begin3+u-1;  // or =(q-1)+(r-1)+(s-1)+(u-1)        -  : TEMA_...[], MainBuffer[]
   begin5=begin4+ul-1; // or =(q-1)+(r-1)+(s-1)+(u-1)+(ul-1) -  : SignalBuffer[]
   //
   rates_total_min=begin5+1; //     
//---        #0
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,begin4);
//---        #1
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,begin5);
//---   
   string shortname=PriceName(AppliedPrice)+","+string(q)+","+string(r)+","+string(s)+","+string(u)+","+string(ul);
   IndicatorSetString(INDICATOR_SHORTNAME,"Blau_SM_Stoch("+shortname+")");
//--- OnInit done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,     //   
                const int prev_calculated, //     
                const datetime &Time[],    // Time
                const double &Open[],      // Open
                const double &High[],      // High
                const double &Low[],       // Low
                const double &Close[],     // Close
                const long &TickVolume[],  // Tick Volume
                const long &Volume[],      // Real Volume
                const int &Spread[]        // Spread
               )
  {
   int i,k,pos;
   double min,max;
   double value1,value2;
//---      
   if(rates_total<rates_total_min) return(0);
//---    PriceBuffer[]
   CalculatePriceBuffer(
                        AppliedPrice,        //  
                        rates_total,         //   
                        prev_calculated,     //     
                        Open,High,Low,Close, //  Open[], High[], Low[], Close[]
                        PriceBuffer          //   
                       );
//---  q-     q-   
   //   (pos),   /        
   //     SMBuffer[], HalfHHLLBuffer[], LLBuffer[], HHBuffer[]
   if(prev_calculated==0)       //   
     {
      pos=begin1;               //  c  ,    
      for(i=0;i<pos;i++)        //   
        {
         SMBuffer[i]=0.0;       //  
         HalfHHLLBuffer[i]=0.0; //
         LLBuffer[i]=0.0;       //
         HHBuffer[i]=0.0;       //
        }
     }
   else pos=prev_calculated-1;  //     
   //     SMBuffer[], HalfHHLLBuffer[], LLBuffer[], HHBuffer[]
   for(i=pos;i<rates_total;i++)
     {
      //  LLBuffer[] -         q
      //  HHBuffer[] -         q
      min=1000000.0;
      max=-1000000.0;
      for(k=i-(q-1);k<=i;k++)
        {
         if(min>Low[k])  min=Low[k];
         if(max<High[k]) max=High[k];
        }
      LLBuffer[i]=min;
      HHBuffer[i]=max;
      //  SMBuffer[] - q-  
      SMBuffer[i]=PriceBuffer[i]-0.5*(LLBuffer[i]+HHBuffer[i]);
      //  HalfHHLLBuffer[] -  q-   
      HalfHHLLBuffer[i]=0.5*(HHBuffer[i]-LLBuffer[i]);
     }
//---   EMA
   // r- 1- EMA
   ExponentialMAOnBufferWB(
                           rates_total,     //   
                           prev_calculated, //     
                           begin1,          //         
                           r,               //  
                           SMBuffer,        //  
                           EMA_SMBuffer     //  
                          );
   ExponentialMAOnBufferWB(rates_total,prev_calculated,begin1,r,HalfHHLLBuffer,EMA_HalfHHLLBuffer);
   // s- 2- EMA
   ExponentialMAOnBufferWB(rates_total,prev_calculated,begin2,s,EMA_SMBuffer,DEMA_SMBuffer);
   ExponentialMAOnBufferWB(rates_total,prev_calculated,begin2,s,EMA_HalfHHLLBuffer,DEMA_HalfHHLLBuffer);
   // u- 3- EMA
   ExponentialMAOnBufferWB(rates_total,prev_calculated,begin3,u,DEMA_SMBuffer,TEMA_SMBuffer);
   ExponentialMAOnBufferWB(rates_total,prev_calculated,begin3,u,DEMA_HalfHHLLBuffer,TEMA_HalfHHLLBuffer);
//---     (   #0)
   //   (pos),   /    
   //     MainBuffer[]
   if(prev_calculated==0)      //   
     {
      pos=begin4;              //  c  ,    
      for(i=0;i<pos;i++)       //   
         MainBuffer[i]=0.0;    //  
     }
   else pos=prev_calculated-1; //     
   //     MainBuffer[]
   for(i=pos;i<rates_total;i++)
     {
      value1=100*TEMA_SMBuffer[i];
      value2=TEMA_HalfHHLLBuffer[i];
      MainBuffer[i]=(value2>0)?value1/value2:0;
     }
//---  Signal Line (   #1)
   ExponentialMAOnBufferWB(rates_total,prev_calculated,begin4,ul,MainBuffer,SignalBuffer);
//--- OnCalculate done. Return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
